import java.awt.*;
import java.awt.image.*;
import java.util.*;

public class Phigsd extends Canvas{
	Image bgImage = null;
	boolean isImageUpdated = false;
	
    int pix[];
	
	public Phigsd(Raster parent) {
        super();
        setBackground(Color.black);
		int h = parent.size().height;
		int w = parent.size().width;
		System.out.println("w = " +w+ ", h = " +h);
		pix = new int[w * h];
		int index = 0;
		for(int y=0; y<h; y++) {
			for(int x=0; x<w; x++) {
				pix[index++] = 0xff000000;
			}
		}
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        Dimension d = size();
		
        while(bgImage == null || isImageUpdated) {
            int w = d.width;
			int h = d.height;
			System.out.println("CreateBGImage!");
			bgImage = createImage(new MemoryImageSource(w, h, pix, 0, w));
			isImageUpdated = false;
		}
		if(bgImage != null) {
			System.out.println("Draw BGImage!");
			g.drawImage(bgImage, 0, 0, this);
		}
	}

    public void set_pixel(int x, int y, int red, int green, int blue) {
		int w = size().width;
		int h = size().height;
		int index = w*(h - y - 1) + x;
		pix[index] = ((int)255 << 24) | (red << 16) | (green << 8) | blue;
    	repaint();
    }
    
    public int get_red(int x, int y) {
		int w = size().width;
		int h = size().height;
		int index = w*(h - y - 1) + x;
		int red = (pix[index] >> 16) & 0xff;
		return(red);
    }
    
    public int get_green(int x, int y) {
		int w = size().width;
		int h = size().height;
		int index = w*(h - y - 1) + x;
		int green = (pix[index] >> 8) & 0xff;
		return(green);
    }
    
    public int get_blue(int x, int y) {
		int w = size().width;
		int h = size().height;
		int index = w*(h - y - 1) + x;
		int blue = pix[index] & 0xff;
		return(blue);
    }
    
    public void setImageUpdate(boolean _isImageUpdated) {
		this.isImageUpdated = _isImageUpdated;
		repaint();
    }
    
    public void clear() {
    	int h = size().height;
		int w = size().width;
		System.out.println("w = " +w+ ", h = " +h);
		int index = 0;
		for(int y=0; y<h; y++) {
			for(int x=0; x<w; x++) {
				pix[index++] = 0xff000000;
			}
		}
    	setImageUpdate(true);
		repaint();
    }
}